
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/wait.h>

#define DIM 10000000

int v[DIM];


int main(void)
{
 int r, p, s, i, n;

 // generazione casuale degli elementi del vettore
 for (i=0; i<DIM; i++)
    v[i] = rand()%1000000;
 
 printf("Inserire il numero da ricercare (0-999999) ");
 scanf("%i", &n);

 r = fork();
 if (r<0)
   {
    printf("Errore!\r\n");
    return 0;
   }
 if (r>0)
   {
    // processo padre: ricerca nella prima parte del vettore
    p = getpid();
    for (i=0; i<DIM/2; i++)
       if (v[i] == n)
         printf("PID %i -> indice=%i\r\n", p, i);
    wait(&s);
    return 1;
   }
 else
     {
      // processo figlio: ricerca nella seconda parte del vettore
      p = getpid();
      for (i=DIM/2; i<DIM; i++)
         if (v[i] == n)
           printf("PID %i -> indice=%i\r\n", p, i);
      return 1;
     }
}
