
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/wait.h>

#define DIM 10000000

int v[DIM];

void search(int first_index, int last_index, int search_value)
{
 int i, p;
 
 p = getpid();
 for (i=first_index; i<=last_index; i++)
    if (v[i] == search_value)
      printf("PID %i -> indice=%i\r\n", p, i);
 return;
}


int main(void)
{
 int r, s, i, n;

 for (i=0; i<DIM; i++)
    v[i] = rand()%1000000;
 
 printf("Inserire il numero da ricercare (0-999999) ");
 scanf("%i", &n);
 
 r = fork();
 if (r<0)
   {
    printf("Errore!\r\n");
    return 0;
   }
 if (r>0)
   {
    r = fork();
    if (r<0)
      {
       printf("Errore!\r\n");
       return 0;
      }
    if (r>0)
      {
       search(0, DIM/4-1, n);
       wait(&s);
       return 1;
      }
    else
        {
         search(DIM/4, DIM/2-1, n);
         return 1;
        }
    wait(&s);
   }
 else
     {
      r = fork();
      if (r<0)
        {
         printf("Errore!\r\n");
         return 0;
        }
      if (r>0)
        {
         search(DIM/2, DIM*3/4-1, n);
         wait(&s);
         return 1;
        }
      else
          {
           search(DIM*3/4, DIM-1, n);
           return 1;
          }
     }
}
