#include <stdio.h>
#include <stdlib.h>
#include <windows.h>

#define DIM 100000000

int v[DIM];
int flag = 0; // 0 = non trovato, 1 = trovato
			  // struttura che definisce i parametri della funzione search
struct PAR
{
	int first_index;
	int last_index;
	int search_value;
};

// funzione che implementa il codice dei thread
unsigned long WINAPI search(void* arg)
{
	int i;
	struct PAR *tmp = (struct PAR*)(arg);
	struct PAR par = *tmp;
	for (i = par.first_index; i <= par.last_index; i++)
	{
		if (v[i] == par.search_value)
			flag = 1;
		if (flag)
			break;
	}
	ExitThread(0);
}
void main(void)
{
	int i, n;
	struct PAR par_1, par_2;
	HANDLE thread[2];

	// generazione casuale degli elementi del vettore
	for (i = 0; i<DIM; i++)
		v[i] = rand() % 10000;
	printf("Inserire il numero da ricercare (0-9999) ");
	scanf("%i", &n);
	// estremi della sezione di ricerca assegnata al primo thread
	par_1.first_index = 0;
	par_1.last_index = DIM / 2 - 1;
	par_1.search_value = n;
	// estremi della sezione di ricerca assegnata al secondo thread
	par_2.first_index = DIM / 2;
	par_2.last_index = DIM - 1;
	par_2.search_value = n;
	// creazione dei thread e attesa della loro terminazione
	thread[0] = CreateThread(NULL, 4096, &search, &par_1, 0, NULL);
	thread[1] = CreateThread(NULL, 4096, &search, &par_2, 0, NULL);
	WaitForMultipleObjects(2, thread, 1, INFINITE);
	if (flag)
		printf("Il valore e' presente nel vettore \r\n");
	else
		printf("Il valore non e' presente nel vettore\r\n");
}